//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FindChange.h"
#pragma package(smart_init)

__fastcall TFindNotify::TFindNotify(AnsiString Path, TNotifyFilters nf, bool WatchSubTree)
        :TThread (true)
{
    FWatchSubTree = WatchSubTree;
    Priority = tpIdle;

    FNotifyFilter = 0;
    if(nf.Contains(ffFileName))
        FNotifyFilter |= FILE_NOTIFY_CHANGE_FILE_NAME;
    if(nf.Contains(ffDirName))
        FNotifyFilter |= FILE_NOTIFY_CHANGE_DIR_NAME;
    if(nf.Contains(ffAttributes))
        FNotifyFilter |= FILE_NOTIFY_CHANGE_ATTRIBUTES;
    if(nf.Contains(ffSize))
        FNotifyFilter |= FILE_NOTIFY_CHANGE_SIZE;
    if(nf.Contains(ffLastWrite))
        FNotifyFilter |= FILE_NOTIFY_CHANGE_LAST_WRITE;
    if(nf.Contains(ffSecurity))
        FNotifyFilter |= FILE_NOTIFY_CHANGE_SECURITY;

    strcpy(FPath, Path.c_str());
}

__fastcall TFindNotify::~TFindNotify ()
{
    Terminate();
    ReleaseMutex(hMutex);
    //̃EFCg
    CloseHandle(hMutex);
}

void __fastcall TFindNotify::Execute ()
{
    HANDLE hFind;
    HANDLE hEvent[2];

    while(!Terminated)
    {
        hFind = FindFirstChangeNotification(FPath, FWatchSubTree, FNotifyFilter);
        if (hFind == NULL || hFind == INVALID_HANDLE_VALUE)
            break;

        hEvent[0] = hFind;
        hEvent[1] = hMutex;

        ResetEvent(hEvent);
        if (WAIT_OBJECT_0 == WaitForMultipleObjects(2, hEvent, false, INFINITE))
            Synchronize (CallOnChange);

        FindCloseChangeNotification(hFind);
    }
}

void __fastcall TFindNotify::CallOnChange(void)
{
    if (FOnChange)
        FOnChange (this);
}

void __fastcall TFindNotify::Start(void)
{
    hMutex = CreateMutex(NULL, true, NULL);

    if (hMutex)
        Resume();
}


