//---------------------------------------------------------------------------

#ifndef FIND_CHANGE_H
#define FIND_CHANGE_H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <SyncObjs.hpp>
//---------------------------------------------------------------------------

enum TFindFilter { ffFileName, ffDirName, ffAttributes, ffSize, ffLastWrite, ffSecurity};

typedef Set<TFindFilter, ffFileName, ffSecurity> TNotifyFilters;

class TFindNotify : public TThread
{
private:
    char FPath[MAX_PATH];
    bool FWatchSubTree;
    unsigned long FNotifyFilter;
    HANDLE hMutex;
    TNotifyEvent FOnChange;
protected:
    void __fastcall Execute ();
    void __fastcall CallOnChange ();
    void __fastcall SetPath();
public:
    __fastcall TFindNotify(AnsiString Path, TNotifyFilters nf, bool WatchSubTree);
    __fastcall ~TFindNotify();
    void __fastcall Start();
    __property TNotifyEvent OnChange = { read = FOnChange, write = FOnChange };
};

#endif	/*	*/
