//---------------------------------------------------------------------------

#ifndef HistoryComboBoxH
#define HistoryComboBoxH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <StdCtrls.hpp>
#include <IniFiles.hpp>
//---------------------------------------------------------------------------
class PACKAGE THistoryComboBox : public TCustomComboBox
{
    typedef TCustomComboBox inherited;

private:
    AnsiString FIniFileName;
    AnsiString FIniSection;
    AnsiString FIgnorePrefix;
    int FMaxItem;
    bool FDropedFind;
    bool Finding;

protected:
    DYNAMIC void __fastcall DoExit(void);
    DYNAMIC void __fastcall Change(void);
    DYNAMIC void __fastcall DropDown(void);
    void __fastcall SetUpdateList(AnsiString _Text);
    void __fastcall SetIgnorePrefix(AnsiString _Prefix);
public:
    __fastcall THistoryComboBox(TComponent* Owner);
    __fastcall virtual ~THistoryComboBox(void);
    void __fastcall SaveToIni(void);
    void __fastcall LoadFromIni(void);
    virtual void __fastcall Loaded(void);

__published:
__property int MaxItem = {read=FMaxItem, write=FMaxItem, default = 20};
    __property AnsiString IniFileName = {read=FIniFileName, write=FIniFileName};
    __property AnsiString IniSection = {read=FIniSection, write=FIniSection};
    __property bool DropedFind = {read=FDropedFind, write=FDropedFind};
    __property AnsiString UpdateList = {write = SetUpdateList};
    __property AnsiString IgnorePrefix = {read = FIgnorePrefix, write = SetIgnorePrefix};
    __property Style ;
    __property Anchors ;
    __property BiDiMode ;
    __property Color ;
    __property Constraints ;
    __property Ctl3D ;
    __property DragCursor ;
    __property DragKind ;
    __property DragMode ;
    __property DropDownCount ;
    __property Enabled ;
    __property Font ;
    __property ImeMode ;
    __property ImeName ;
    __property ItemHeight ;
    __property MaxLength ;
    __property ParentBiDiMode ;
    __property ParentColor ;
    __property ParentCtl3D ;
    __property ParentFont ;
    __property ParentShowHint ;
    __property PopupMenu ;
    __property ShowHint ;
    __property Sorted ;
    __property TabOrder ;
    __property TabStop ;
    __property Text ;
    __property Visible ;
    __property OnChange ;
    __property OnClick ;
    __property OnContextPopup ;
    __property OnDblClick ;
    __property OnDragDrop ;
    __property OnDragOver ;
    __property OnDrawItem ;
    __property OnDropDown ;
    __property OnEndDock ;
    __property OnEndDrag ;
    __property OnEnter ;
    __property OnExit ;
    __property OnKeyDown ;
    __property OnKeyPress ;
    __property OnKeyUp ;
    __property OnMeasureItem ;
    __property OnStartDock ;
    __property OnStartDrag ;
    __property Items ;
};
//---------------------------------------------------------------------------
#endif
