//---------------------------------------------------------------------------

#ifndef HttpClientH
#define HttpClientH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <ScktComp.hpp>
#include "URLParser.h"
//---------------------------------------------------------------------------

typedef void __fastcall (__closure *TDoneEvent)(System::TObject* Sender, int Code);

class PACKAGE THttpClient : public TCustomSocket
{
private:
    AnsiString FURL;
    AnsiString FSource;
    AnsiString FHeader;

    URLParser FParser;
    TClientWinSocket *FClientSocket;
    TDoneEvent FOnDone;
protected:
    void __fastcall DoActivate(bool Value)
    {}
    void __fastcall Open(URLParser parser);
    void __fastcall SetURL(AnsiString _url);
    void __fastcall Event(TCustomWinSocket* Socket, TSocketEvent SocketEvent);
    void __fastcall SetHeader(AnsiString Str);
    void __fastcall SetSource(AnsiString Str);
    void __fastcall SetResponseData(TCustomWinSocket* Socket);
    void __fastcall SetRequestHeader(TCustomWinSocket* Socket);
    void __fastcall Disconnected();
public:
    THttpClient();
    __fastcall THttpClient(TComponent* Owner);
    virtual __fastcall ~THttpClient();
    void __fastcall Get(AnsiString Url);
    void __fastcall Post(AnsiString Url, AnsiString Param);
    void __fastcall Delete(AnsiString Url);
    void __fastcall Trace(AnsiString Url);
    void __fastcall Option(AnsiString Url);
    __property TClientWinSocket *Socket = {read = FClientSocket};
__published:
    //    __property Active;
    __property AnsiString URL = {read = FURL, write = SetURL};
    //    __property TClientType ClientType = {read = GetClientType, write = SetClientType};
    //    __property Host;
    //    __property Port;
    //    __property Service;

    __property TDoneEvent OnDone = {read = FOnDone, write = FOnDone};
    __property AnsiString Source = {read = FSource};
    __property AnsiString Header = {read = FHeader};


    __property OnLookup;
    __property OnConnecting;
    __property OnConnect;
    __property OnDisconnect;
    __property OnRead;
    __property OnWrite;
    __property OnError;


};
//---------------------------------------------------------------------------
#endif
