
#include <vcl.h>
#pragma hdrstop

#include "ItemID.h"
#pragma package(smart_init)

PItemIDList __fastcall CopyOneItemID(PItemIDList ItemID)
{
    PItemIDList OneItemID;
    int OneItemIDSize = ItemID->mkid.cb + sizeof(ItemID->mkid.cb) + sizeof(_ITEMIDLIST);

    OneItemID = (PItemIDList)CoTaskMemAlloc(OneItemIDSize);

    memset(OneItemID, 0, OneItemIDSize);
    memcpy(OneItemID, ItemID, ItemID->mkid.cb);

    return OneItemID;
}

PItemIDList CreateItemID(int Size)
{
    PItemIDList ItemID;

    ItemID = (PItemIDList)CoTaskMemAlloc( Size );
    memset(ItemID, 0, Size);
    return ItemID;
}

PItemIDList NextItemID(PItemIDList ItemIDList)
{
    LPITEMIDLIST resIDList;

    resIDList = (LPITEMIDLIST)((int)ItemIDList + ItemIDList->mkid.cb);
    return resIDList;
}

PItemIDList CopyItemID(PItemIDList ItemIDList)
{
    int Size;
    PItemIDList NewIIDList;

    Size = GetItemIDSize(ItemIDList) + sizeof(ItemIDList->mkid.cb);
    NewIIDList = CreateItemID(Size);
    memcpy(NewIIDList, ItemIDList, Size );
    return NewIIDList;
}

PItemIDList GetParentItemID(PItemIDList ItemIDList)
{
    /*
        int Size;
        PItemIDList NewIIDList = CopyItemID(ItemIDList);
        PItemIDList CurrentIID = NewIIDList;
        PItemIDList ItemID     = NewIIDList;
     
        while( CurrentIID->mkid.cb != NULL )
        {
            CurrentIID = NextItemID( CurrentIID );
            if (CurrentIID->mkid.cb != NULL)
                ItemID     = CurrentIID;
            else
                ItemID->mkid.cb = 0;
        }
     
        return NewIIDList;
    */
    PItemIDList NewIIDList = CopyItemID(ItemIDList);
    PItemIDList CurrentIID = NewIIDList;
    PItemIDList ItemID;

    while( CurrentIID->mkid.cb != 0 )
    {
        ItemID = NextItemID( CurrentIID );

        if (ItemID->mkid.cb == 0)
        {
            CurrentIID->mkid.cb = 0;
        }
        CurrentIID = ItemID;
    }
    return NewIIDList;
}

int GetItemIDSize(PItemIDList IDList)
{
    int Size = 0;

    if( IDList != NULL )
    {
        Size = sizeof(IDList->mkid.cb);
        while( IDList->mkid.cb != NULL )
        {
            Size += (int)IDList->mkid.cb;
            IDList = NextItemID( IDList );
        }
    }
    return Size;
}

PItemIDList ConcatItemID( PItemIDList IDList1, PItemIDList IDList2 )
{
    int Size1 = 0;
    int Size2 = 0;
    PItemIDList NewIDList;

    if (IDList1 != NULL)
        Size1 = GetItemIDSize( IDList1 ) - sizeof(IDList1->mkid.cb);

    if (IDList2 != NULL)
        Size2 = GetItemIDSize( IDList2 );

    NewIDList = CreateItemID( Size1 + Size2 );
    if( NewIDList != NULL )
    {
        if (IDList1 != NULL)
        {
            memcpy( NewIDList, IDList1, Size1 );
        }
        memcpy((LPBYTE)NewIDList + Size1 , IDList2, Size2 );
    }
    return NewIDList;
}

int GetShellImage(PItemIDList ItemID , bool large, bool open)
{
    SHFILEINFO FileInfo;
    int Flags;

    memset(&FileInfo, 0, sizeof(FileInfo));
    Flags = SHGFI_PIDL | SHGFI_SYSICONINDEX | SHGFI_ICON;

    if (large)
    {
        Flags |= SHGFI_LARGEICON;
    }
    else
    {
        Flags |= SHGFI_SMALLICON;
    }

    if (open)
    {
        Flags = Flags | SHGFI_OPENICON;
    }

    SHGetFileInfo((char*)ItemID, 0, &FileInfo, sizeof(FileInfo), Flags);
    return FileInfo.iIcon;
}

AnsiString GetDisplayName(_di_IShellFolder ShellFolder ,PItemIDList ItemID, bool ForParsing)
{
    TStrRet StrRet;
    char* p;
    char displayName[255];
    int Flags;

    ForParsing == true ? Flags = SHGDN_FORPARSING : Flags = SHGDN_NORMAL;

    ShellFolder->GetDisplayNameOf(ItemID, Flags, &StrRet);

    switch (StrRet.uType)
    {
    case STRRET_CSTR:
        return AnsiString(StrRet.cStr);
    case STRRET_OFFSET:
        p = &ItemID->mkid.abID[StrRet.uOffset - sizeof(ItemID->mkid.cb)];
        return AnsiString(p);
    case STRRET_WSTR:
        WideCharToMultiByte( CP_ACP, 0, StrRet.pOleStr, -1, displayName, sizeof(displayName), 0,0);
        CoTaskMemFree(StrRet.pOleStr);
        return AnsiString(displayName);
    }
    return "";
}
