
#ifndef _MBString_H_
#define _MBString_H_

enum CharSet
{
    BINARY,
    ISO_2022_JP,
    SHIFT_JIS,
    EUC_JP,
    USASCII,
    UNKNOWN
};

class MBString
{
private:
    char* data;
    int charcode;
    int length;

    void Init (char* _s, CharSet code);
    int CodeDetect (unsigned char *_s);
    int GetCRLFCount (char *_s);
    char* JISToSJIS (unsigned char *_s1, unsigned char *_s2);
    char* EUCToSJIS (unsigned char *_s1, unsigned char *_s2);
    char* LFToCRLF (unsigned char *_dest, unsigned char *_src);
public:
    MBString (MBString & coder);
    MBString (char* _s);
    MBString (char* _s, CharSet code);
    virtual ~MBString ();

    const char* ToStr ();
    void SetLength (int alloc_len);
    int Size ();
};


#endif	/* _MBString_H_ */

